<?php

namespace D3\XRechnungForOxid\Modules\Application\Controller\Admin;

use OxidEsales\Eshop\Application\Model\Order;
use OxidEsales\Eshop\Core\Registry;

class OrderOverview extends OrderOverview_parent
{
    public function createXRechnung()
    {
        $soxId = $this->getEditObjectId();
        if ($soxId != "-1" && isset($soxId)) {
            // load object
            $oOrder = oxNew(Order::class);
            if ($oOrder->load($soxId))
            {

                //todo add check for filetype -> xml302, for older oder newer version
                $oUtils = Registry::getUtils();
                $sTrimmedBillName = trim($oOrder->oxorder__oxbilllname->getRawValue());
                if(!$sTrimmedBillName) {
                    return FALSE;
                }
                else {
                    $strx = array('#[^a-zA-Z0-9\040]#','# +#','##','##','##','##');
                    $stry = array(' ',' ','ae','oe','ue','ss');
                    $sTrimmedBillName=preg_replace($strx,$stry,$sTrimmedBillName);
                    $sTrimmedBillName=trim($sTrimmedBillName);
                    $sTrimmedBillName=strtolower($sTrimmedBillName);
                }
                $sFilename = $oOrder->oxorder__oxordernr->value . "_" . $sTrimmedBillName . ".xml";
                $sFilename = $this->makeValidFileName($sFilename);

                $sReturn =  $oOrder->genXRechnung($sFilename, Registry::getConfig()->getRequestParameter("xmllanguage"), false);
                $aReturn = $this->prepareFromTansport($sReturn);
                $sFilename = $aReturn['FileName'];

                $Config = Registry::getConfig();

                $sExportFolder = "export/xml";
                if(trim($Config->getConfigParam("d3xrechnung_EXPORT_FOLDER")) != '')
                {
                    $sExportFolder = $Config->getConfigParam("d3xrechnung_EXPORT_FOLDER");
                }
                ob_start();
                echo file_get_contents($Config->getConfigParam('sShopDir')."/".$sExportFolder."/".$sFilename);
                $sXML = ob_get_contents();
                ob_end_clean();
                $oUtils->setHeader("Pragma: public");
                $oUtils->setHeader("Cache-Control: must-revalidate, post-check=0, pre-check=0");
                $oUtils->setHeader("Expires: 0");
                $oUtils->setHeader("Content-type: application/xml");
                $oUtils->setHeader("Content-Disposition: attachment; filename=" . $sFilename);
                Registry::getUtils()->showMessageAndExit($sXML);
            }
        }
    }

    public function saveXRechnung()
    {
        $oConfig = $this->getConfig();
        $aParams = $oConfig->getRequestParameter("editvalBT");
        $TmpBtFields = array();
        foreach ($aParams as $key => $value)
        {
            if(trim($value['VALUE']) != '') {
                $key = strtoupper($value['FIELD']);
                $key = trim($key);
                $key = str_replace('-','', $key);
                $value = trim($value['VALUE']);
                $TmpBtFields[$key] = $value;
            }
        }
        $sBtField = serialize($TmpBtFields);
        $soxId = $this->getEditObjectId();
        if ($soxId != "-1" && isset($soxId)) {
            // load object
            $oOrder = oxNew(Order::class);
            if ($oOrder->load($soxId)) {
                $oConfig = $this->getConfig();
                $aParams = $oConfig->getRequestParameter("editval");
                $oOrder->assign(
                    array(
                        'd3leitwegid' => trim($aParams["oxorder__d3leitwegid"]),
                        'd3btfields' => $sBtField
                    )
                );
                $oOrder->save();
            }
        }
    }

    public function getBtFieldsXRechnung()
    {
        /** @var Order::class $oOrder */
        $oOrder = oxNew(Order::class);
        $soxId = $this->getEditObjectId();
        $aFields = array();
        if (isset($soxId) && $soxId != "-1") {
            $oOrder->load($soxId);
            $sFields = $oOrder->oxorder__d3btfields->getRawValue();

            $aFields = unserialize($sFields);
        }
        ksort($aFields, SORT_NATURAL);
        //dumpvar($aFields);
        return $aFields;
    }

    /**
     * @param string $Data
     * @return array
     */
    public function prepareFromTansport(string $Data): array
    {
        return (array)json_decode(base64_decode($Data));
    }
}
